using System;
using System.Globalization;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
//using System.Windows.Forms;
using Microsoft.Win32;
using ShellExt; 
using System.Text;
using System.IO;


[assembly:AssemblyKeyFile("..\\..\\CleanVS.snk")]			// Strong name keyfile for this assembly
[assembly:ComVisible(false)]						// Make sure that no interfaces are registered with COM


namespace CleanVS
{

  [Guid("2AA8DDCB-0540-4cd3-BD31-D91DADD81ED3"), ComVisible(true)]
  public class CleanVS : IContextMenu, IShellExtInit 
  {
    public CleanVS() {}

    const string clsid = "{2AA8DDCB-0540-4cd3-BD31-D91DADD81ED3}";

    IDataObject	m_dataObject = null;
    uint m_hDrop = 0;

    #region Registration

    [System.Runtime.InteropServices.ComRegisterFunctionAttribute()]
    static void RegisterServer(String zRegKey) 
    {
      try 
      {
        RegistryKey root;
        RegistryKey rk;

        root = Registry.CurrentUser;
        rk = root.OpenSubKey("Software\\Microsoft\\Windows\\" + 
                            "CurrentVersion\\Explorer", true);
        rk.SetValue("DesktopProcess", 1);
        rk.Close();

        // For Winnt set me as an approved shellex
        root = Registry.LocalMachine;
        rk = root.OpenSubKey("Software\\Microsoft\\Windows\\" + 
                            "CurrentVersion\\Shell Extensions\\" + 
                            "Approved", true);
        rk.SetValue(clsid, "CleanVS Shell Extension");
        rk.Close();

        root = Registry.ClassesRoot;
        rk = root.CreateSubKey("Folder\\shellex\\" + 
                              "ContextMenuHandlers\\CleanVS");
        rk.SetValue("", clsid);
        rk.Close();


      }
      catch(Exception e) 
      {
        System.Console.Error.WriteLine(e.ToString());
      }
    }

    [System.Runtime.InteropServices.ComUnregisterFunctionAttribute()]
    static void UnregisterServer(String zRegKey) 
    {
      try 
      {
        RegistryKey root;
        RegistryKey rk;

        // Remove ShellExtenstions registration
        root = Registry.LocalMachine;
        rk = root.OpenSubKey("Software\\Microsoft\\Windows\\" + 
                            "CurrentVersion\\Shell Extensions\\" + 
                            "Approved", true);
        rk.DeleteValue(clsid);
        rk.Close();

        // Delete ShellCmd regkey
        root = Registry.ClassesRoot;
        root.DeleteSubKey("Folder\\shellex\\ContextMenuHandlers\\" + 
                          "CleanVS");

      }
      catch(Exception e) 
      {
        System.Console.Error.WriteLine(e.ToString());
      }
    }

    static void Usage()
    {
      System.Console.WriteLine("Syntax: CleanVS [Options]\nOptions:\n    /u             Uninstall the shell extension\n    /? or /help    Display this usage message");
    }

    public static int	Main(string[] args)
    {
      bool unregister = false;

      try
      {
        Console.WriteLine("CleanVS.exe - Windows explorer " + 
                          "namespace extension for cleaning up " + 
                          "of temporary files from Visual Studio " +
                          "Project Directories\n" + 
                          "Copyright (C) Shawn Wildermuth 2003.  " + 
                          "All rights reserved.");

        if(args.Length == 1)
        {
          string a = args[0].Replace('-', '/').ToLower(CultureInfo.InvariantCulture);
          if (a == "/?" || args[0] == "/help")
          {
            Usage();
            return 0;
          }
          else if (a == "/u")
          {
            unregister = true;
          }
          else
          {
            Console.WriteLine("Invalid option: " + args[0]);
            Usage();
            return 1;
          }
        }

        // (Un)Register if necessary
        Assembly asm = Assembly.GetExecutingAssembly();	
        RegistrationServices reg = new RegistrationServices();
        if(unregister)
        {
          reg.UnregisterAssembly(asm);
          CleanVS.UnregisterServer("");
        }
        else
        {
          reg.RegisterAssembly(asm, 
            AssemblyRegistrationFlags.SetCodeBase);
          CleanVS.RegisterServer("");
        }
        return 0;
      }
      catch(Exception e)
      {
        Console.WriteLine("An exception was thrown : " + e);
        return 1;
      }
    }
    #endregion

    #region Functional Implementation
    bool IsDirectorySelected(uint uFlags)
    {
      if ( (uFlags & (uint)CMF.CMF_DEFAULTONLY) == 0)
      {
        uint nselected = DllImports.DragQueryFile(m_hDrop, 
          0xffffffff, 
          null, 
          0);
        if (nselected == 1)
        {
          StringBuilder sb = new StringBuilder(1024);
          DllImports.DragQueryFile(m_hDrop, 0, sb, sb.Capacity + 1);
          string directory = sb.ToString();
          uint attr = DllImports.GetFileAttributes(directory);
          if ((attr & DllImports.FILE_ATTRIBUTE_DIRECTORY) != 0)
          {
            // Is a Directory
            return true;
          }
        }
      }

      // No Directory
      return false;
    }

    string[] patterns = new string[] { "*.obj", "*.pdb", "*.projdata", "*.resources", "*.user", "*.suo" };
    CleanStatus statusDlg = new CleanStatus();

    void CleanDirectory(string path)
    {
      // See if it is an obj directory
      if (path.ToLower().EndsWith("\\obj"))
      {
        // Show Statuss
        ChangeStatus(string.Format("Deleting {0} directory", path));

        // If the parent directory ahs a project file or a solution file, then delete the obj directory completely
        if (Directory.GetFiles(path.Substring(0, path.Length -3), "*.??proj").Length > 0 ||
          Directory.GetFiles(path.Substring(0, path.Length -3), "*.sln").Length > 0)
        {
          try
          {
            Directory.Delete(path, true);
          }
          catch
          {
          }
        }
      }
      else
      {
        // Delete Specific Files
        foreach (string pattern in patterns)
        {
          // Get the files of that pattern
          string[] files = Directory.GetFiles(path, pattern);

          // Go through each found file
          foreach (string file in files)
          {
            // If it exists
            if (File.Exists(file))
            {
              // Show Statuss
              ChangeStatus(string.Format("Deleting file: {0}", file));
              try
              {

                // Kill it
                File.Delete(file);
              }
              catch
              {
              }
            }
          }
        }

        // Call recursively
        string[] dirs = Directory.GetDirectories(path);
        foreach (string dir in dirs)
        {
          CleanDirectory(dir);
        }
      }
    }

    public void ChangeStatus(string msg)
    {
      statusDlg.status.Text = msg;
      if (statusDlg.progress.Value < statusDlg.progress.Maximum)
      {
        statusDlg.progress.Increment(1);
      }
      else
      {
        statusDlg.progress.Value = 1;
      }
    }

    #endregion

    #region IContextMenu Members

    int IContextMenu.QueryContextMenu(uint hmenu, 
      uint iMenu, 
      int idCmdFirst, 
      int idCmdLast, 
      uint uFlags)
    {
      // The first id to use (should be 1)
      int id = 1;

      // If its a directory we can show the menu item
      if (IsDirectorySelected(uFlags))
      {
        // Create a new Menu Item to add to the popup menu
        MENUITEMINFO mii = new MENUITEMINFO();
        mii.cbSize		= 48;
        mii.fMask		= (uint)MIIM.ID | (uint)MIIM.TYPE | (uint)MIIM.STATE;
        mii.wID			= idCmdFirst + id;
        mii.fType		= (uint)MF.STRING;
        mii.dwTypeData	= "Clean VS.NET Temp Files";
        mii.fState		= (uint)MF.ENABLED;

        // Add it to the item
        DllImports.InsertMenuItem(hmenu, (uint)2, 1, ref mii);

        // Since we only added a single item, 
        // just increment the id by 1
        id++;
      }

      // Return the new id number if we actually added an item
      return id;
    }

    void IContextMenu.InvokeCommand(IntPtr pici)
    {
      try
      {
        StringBuilder sb = new StringBuilder(1024);

        // Get the Directory Information
        DllImports.DragQueryFile(m_hDrop, 0, sb, sb.Capacity + 1);
        string directory = sb.ToString();

        // Show Status Form
        statusDlg.Show();

        CleanDirectory(directory);

      }
      catch(Exception e)
      {
        System.Windows.Forms.MessageBox.Show("Error : " + e.ToString(), 
          "Error in CleanVS");
      }
      finally
      {
        // Hide the status window
        statusDlg.Hide();
      }
    }

    void IContextMenu.GetCommandString(int idcmd, 
                                      uint uflags, 
                                      int reserved, 
                                      StringBuilder commandstring, 
                                      int cch)
    {
      switch(uflags)
      {
        case (uint)GCS.VERB:
          commandstring = new StringBuilder("CleanVS".Substring(1, cch-1));
          break;
        case (uint)GCS.HELPTEXT:
        {
          commandstring = new StringBuilder("Removes all temporary files " + 
            "from a directory (and sub directories) from Visual " + 
            "Studio Builds".Substring(1, cch-1));
          break;
        }
        case (uint)GCS.VALIDATE:
          break;
      }
    }

    #endregion

    #region IShellExtInit Members

    int IShellExtInit.Initialize(IntPtr pidlFolder, 
      IntPtr lpdobj, 
      uint hKeyProgID)
    {
      try
      {
        m_dataObject = null;
        if (lpdobj != (IntPtr)0)
        {
          // Get info about the directory
          m_dataObject = 
            (ShellExt.IDataObject)Marshal.GetObjectForIUnknown(lpdobj);
          FORMATETC fmt = new FORMATETC();
          fmt.cfFormat = CLIPFORMAT.CF_HDROP;
          fmt.ptd		 = 0;
          fmt.dwAspect = DVASPECT.DVASPECT_CONTENT;
          fmt.lindex	 = -1;
          fmt.tymed	 = TYMED.TYMED_HGLOBAL;
          STGMEDIUM medium = new STGMEDIUM();
          m_dataObject.GetData(ref fmt, ref medium);
          m_hDrop = medium.hGlobal;

        }
      }
      catch(Exception)
      {
      }
      return 0;
    }

    #endregion
  }
}
